import * as _ from "@preserves/core";
import * as _i_EntityRef from "../runtime/actor";

export const __lit0 = Symbol.for("require-service");
export const __lit1 = Symbol.for("service-running");

export type _embedded = _i_EntityRef.Ref;

export type RequireService<_embedded = _i_EntityRef.Ref> = {"serviceName": _.Value<_embedded>};

export type ServiceRunning<_embedded = _i_EntityRef.Ref> = {"serviceName": _.Value<_embedded>};


export function RequireService<_embedded = _i_EntityRef.Ref>(serviceName: _.Value<_embedded>): RequireService<_embedded> {return {"serviceName": serviceName};}

export function ServiceRunning<_embedded = _i_EntityRef.Ref>(serviceName: _.Value<_embedded>): ServiceRunning<_embedded> {return {"serviceName": serviceName};}

export function asRequireService<_embedded = _i_EntityRef.Ref>(v: _.Value<_embedded>): RequireService<_embedded> {
    let result = toRequireService(v);
    if (result === void 0) throw new TypeError(`Invalid RequireService: ${_.stringify(v)}`);
    return result;
}

export function toRequireService<_embedded = _i_EntityRef.Ref>(v: _.Value<_embedded>): undefined | RequireService<_embedded> {
    let result: undefined | RequireService<_embedded>;
    if (_.Record.isRecord<_.Value<_embedded>, _.Tuple<_.Value<_embedded>>, _embedded>(v)) {
        let _tmp0: (null) | undefined;
        _tmp0 = _.is(v.label, __lit0) ? null : void 0;
        if (_tmp0 !== void 0) {
            let _tmp1: (_.Value<_embedded>) | undefined;
            _tmp1 = v[0];
            if (_tmp1 !== void 0) {result = {"serviceName": _tmp1};};
        };
    };
    return result;
}

export function fromRequireService<_embedded = _i_EntityRef.Ref>(_v: RequireService<_embedded>): _.Value<_embedded> {return _.Record(__lit0, [_v["serviceName"]]);}

export function asServiceRunning<_embedded = _i_EntityRef.Ref>(v: _.Value<_embedded>): ServiceRunning<_embedded> {
    let result = toServiceRunning(v);
    if (result === void 0) throw new TypeError(`Invalid ServiceRunning: ${_.stringify(v)}`);
    return result;
}

export function toServiceRunning<_embedded = _i_EntityRef.Ref>(v: _.Value<_embedded>): undefined | ServiceRunning<_embedded> {
    let result: undefined | ServiceRunning<_embedded>;
    if (_.Record.isRecord<_.Value<_embedded>, _.Tuple<_.Value<_embedded>>, _embedded>(v)) {
        let _tmp0: (null) | undefined;
        _tmp0 = _.is(v.label, __lit1) ? null : void 0;
        if (_tmp0 !== void 0) {
            let _tmp1: (_.Value<_embedded>) | undefined;
            _tmp1 = v[0];
            if (_tmp1 !== void 0) {result = {"serviceName": _tmp1};};
        };
    };
    return result;
}

export function fromServiceRunning<_embedded = _i_EntityRef.Ref>(_v: ServiceRunning<_embedded>): _.Value<_embedded> {return _.Record(__lit1, [_v["serviceName"]]);}

